<Query Kind="Statements">
  <Namespace>System.Text.Json.Nodes</Namespace>
</Query>

var node = JsonNode.Parse (@"{ ""Name"":""Alice"", ""Age"": 32}").Dump ("JsonObject");
Debug.Assert (node is JsonObject);

string name = (string)node ["Name"];   // Alice
int age = (int)node ["Age"];           // 32

new { name, age }.Dump();

// Enumerate over the dictionary’s key/value pairs:
foreach (KeyValuePair<string, JsonNode> keyValuePair in node.AsObject())
{
	string propertyName = keyValuePair.Key;
	JsonNode value = keyValuePair.Value;
	new { propertyName, value }.Dump();
}

if (node.AsObject().TryGetPropertyValue ("Name", out JsonNode nameNode))
{
	nameNode.Dump ("JsonObject has a Name property");
}