<Query Kind="Statements">
  <Namespace>System.Threading.Tasks</Namespace>
  <Namespace>System.Net</Namespace>
  <Namespace>System.Collections.Concurrent</Namespace>
</Query>

Util.AutoScrollResults = true;

// These are the 50 URIs that we want to download.
var uris = Enumerable.Range (0, 50).Select (i => "http://SomeUri/" + i);

await Parallel.ForEachAsync (uris,
	new ParallelOptions
	{
		MaxDegreeOfParallelism = 5,           // Limit concurrency to a maximum of 5 downloads at a time.
		CancellationToken = QueryCancelToken  // Use LINQPad's cancellation token. Test by pressing Stop button on toolbar.
	},
	async (uri, cancelToken) =>
	{
		var progressBar = new Util.ProgressBar ("Downloading " + uri, true).Dump();
		
		// Simulate delay while downloading
		for (int i = 0; i <= 10; i++)
		{
			await Task.Delay (100, cancelToken);
			progressBar.Percent = i * 10;
		}
		$"Downloaded {uri}".Dump();
	});